﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TreeViewAdv
{
    /// <summary>
    /// Interaktionslogik für CustomTreeControl.xaml
    /// </summary>
    public partial class CustomTreeControl : UserControl
    {
        public CustomTreeControl()
        {
            InitializeComponent();
            Loaded += CustomTreeControl_Loaded;
           
        }

        //setting the DataContext in the CustomTreeControl loaded event
        private void CustomTreeControl_Loaded(object sender, RoutedEventArgs e)
        {
            //You can uncomment this to work properly
            //this.DataContext = new HierarchicalViewModel();
        }

        public class Model
        {
            public Model()
            {
                RelatedItems = new ObservableCollection<Model1>();
            }
            public string Name { get; set; }
            public ObservableCollection<Model1> RelatedItems { get; set; }
        }
        public class Model1
        {
            public Model1()
            {
                SubItems = new ObservableCollection<Model2>();
            }
            public string Name { get; set; }
            public ObservableCollection<Model2> SubItems { get; set; }
        }
        public class Model2
        {
            public string Name { get; set; }
        }
        public class HierarchicalViewModel

        {

            public HierarchicalViewModel()

            {

                TreeItems = new ObservableCollection<Model>();

                PopulateData();

            }

            public ObservableCollection<Model> TreeItems { get; set; }

            private void PopulateData()

            {

                Model root1 = new Model() { Name = "Send/Receive" };
                Model1 subItem1 = new Model1 { Name = "Download" };
                subItem1.SubItems.Add(new Model2() { Name = "Show Progress" });
                subItem1.SubItems.Add(new Model2() { Name = "Cancel All" });
                root1.RelatedItems.Add(subItem1);
                Model1 subItem2 = new Model1 { Name = "Preferences" };
                subItem2.SubItems.Add(new Model2() { Name = "Download Preferences" });
                subItem2.SubItems.Add(new Model2() { Name = "Work Offline" });
                root1.RelatedItems.Add(subItem2);
                Model root2 = new Model() { Name = "View" };
                Model1 subItem3 = new Model1 { Name = "Window" };
                subItem3.SubItems.Add(new Model2() { Name = "Reminders Window" });
                root2.RelatedItems.Add(subItem3);
                TreeItems.Add(root1);
                TreeItems.Add(root2);

            }
        }
    }
}